# -*- coding: utf-8 -*-
"""Lab 7 - Regularization.ipynb

Automatically generated by Colaboratory.

Original file is located at
    https://colab.research.google.com/drive/1s40ezsY93kxHouGwRMAWVpn0Ww-sp_b8

# ITS307 Data Analytics                                                   : Spring Semester 2022
# Practical 6
# Regularization
![image.png](attachment:image.png)

# 1. Import Libraries
"""

import pandas as pd
import matplotlib as plt 
import numpy as np
from sklearn import datasets

boston = datasets.load_boston()
print(boston.DESCR)

"""# 2. Load Data"""

df = pd.DataFrame(data=boston.data,columns=boston.feature_names)
df.head()

X = boston.data
y = boston.target

"""# 3. Train test split"""

from sklearn.model_selection import train_test_split
xtrain, xtest, ytrain, ytest = train_test_split(X, y, test_size = 0.3)

"""# 4. Simple Linear Model"""

from sklearn.linear_model import LinearRegression
lr = LinearRegression()
lr.fit(xtrain, ytrain)

lr.score(xtrain, ytrain)

lr.score(xtest, ytest)

"""# 5. Ridge Regularization for Linear Model"""

from sklearn.linear_model import Ridge
modelr = Ridge(alpha=1)
modelr.fit(xtrain,ytrain)
modelr.score(xtrain,ytrain)

modelr.score(xtest, ytest)

"""# 6. Lasso Regularization for Linear Model"""

from sklearn.linear_model import Lasso
modelL = Lasso(alpha=0.1)
modelL.fit(xtrain,ytrain)
modelL.score(xtrain,ytrain)

modelL.score(xtest, ytest)

"""# 7. Polynomial Regression of degree 2"""

from sklearn.preprocessing import PolynomialFeatures
pf = PolynomialFeatures(degree=2)
xtrain_poly = pf.fit_transform(xtrain)
xtest_poly = pf.fit_transform(xtest)

lrp = LinearRegression()
lrp.fit(xtrain_poly,ytrain)
lrp.score(xtrain_poly,ytrain)

lrp.score(xtest_poly,ytest)

"""# 8. Ridge Regularization for Polynomial model"""

modelrp =  Ridge(alpha=10000000)
modelrp.fit(xtrain_poly,ytrain)
modelrp.score(xtrain_poly,ytrain)

modelrp.score(xtest_poly,ytest)

"""# 9. Lasso Regularization for Polynomial model"""

modelrpl = Lasso(alpha=1)
modelrpl.fit(xtrain_poly,ytrain)
modelrpl.score(xtrain_poly,ytrain)

modelrpl.score(xtest_poly,ytest)

"""# 10. Select K Best"""

from sklearn.feature_selection import SelectKBest
from sklearn.feature_selection import f_regression
kb = SelectKBest(score_func=f_regression,k=7)
x_selected = kb.fit_transform(xtrain,ytrain)
x_selected[0]

model = LinearRegression()
model.fit(x_selected,ytrain)

model.score(x_selected,ytrain)

columns = ['LSTAT', 'ZN', 'INDUS', 'RM', 'TAX', 'PTRARIO']

tdf = pd.DataFrame(data= xtest,columns=boston.feature_names)
tdf.head()

#corrlation bw high score target
traindf = pd.DataFrame(data=xtrain, columns= boston.feature_names)
traindf['target'] = ytrain
traindf.head()

corr = traindf.corr()

import matplotlib.pyplot as plt
import seaborn as sns
sns.set(rc={'figure.figsize':(15,10)})
sns.heatmap(data = corr,annot = True)
plt.show()

selected_columns = ['CRIM', 'INDUS', 'NOX', 'RM', 'TAX', 'PTRATIO', 'LSTAT']

train_selected = traindf[selected_columns]
test_selected = tdf[selected_columns]
test_selected.head()

"""# 11. Conclusion

We can conclude that, we need to use regularization as it helps to choose preferred model complexity, so that model is better at predicting.

In the ridge, the coefficients of the linear transformation are normal distributed and in the lasso they are Laplace distributed. In the lasso, this makes it easier for the coefficients to be zero and therefore easier to eliminate some of our input variable as not contributing to the output.

Lasso regression will automatically select those features that are useful, discarding the useless or redundant features. In Lasso regression, discarding a feature will make its coefficient equal to 0. So, the idea of using Lasso regression for feature selection purposes is very simple: we fit a Lasso regression on a scaled version of our dataset.
"""